void SetCharSource(char** Vals, void* TargetStruct, void* TempStruct, int Number, bool header)
{
	int i;

	static int prob, tw, ga, rwref, rwwil, rwzaeh, attack, skills, prestige, maxlvl, name, attr[6], valcount;
	static int scriptpos, spellpos, incspellpos, spontanpos, domainpos, specialpos, powerpos, reqpos, skillreqpos;
	static int classfeatpos, featreqpos, bonusfeattypepos, bonusfeatpos, epicfeatpos, spellfailpos, useeffectspos;
	static int attachclasspos, noeqpos, psidispos, psicryspos, forceattackpos, forceweapontypepos, naturalenhpos;
	static int derrivepos, copyspellpos, npcpos, spellattrpos, bonusclassskillpos, spelltype2pos;
	static int forceweaponpos, nometalpos;

	if (header)
	{
		prob = GetValNumber(Vals, "Probability", Number);
		ga = GetValNumber(Vals, "GAType", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zh", Number);
		attack = GetValNumber(Vals, "Attack", Number);
		skills = GetValNumber(Vals, "Skills", Number);
		prestige = GetValNumber(Vals, "Prest", Number);
		maxlvl = GetValNumber(Vals, "MaxLvl", Number);
		name = GetValNumber(Vals, "Name", Number);
		tw = GetValNumber(Vals, "TW", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		spellpos = GetValNumber(Vals, "SpellType", Number);
		spelltype2pos = GetValNumber(Vals, "SpellType2", Number);
		incspellpos = GetValNumber(Vals, "IncreaseSpellType", Number);
		spontanpos = GetValNumber(Vals, "SpontanCast", Number);
		domainpos = GetValNumber(Vals, "Domains", Number);
		specialpos = GetValNumber(Vals, "Specialize", Number);
		powerpos = GetValNumber(Vals, "PowerType", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillreqpos = GetValNumber(Vals, "SkillReq", Number);
		classfeatpos = GetValNumber(Vals, "GiveFeats", Number);
		featreqpos = GetValNumber(Vals, "FeatReq", Number);
		bonusfeattypepos = GetValNumber(Vals, "BonusFeatType", Number);
		bonusfeatpos = GetValNumber(Vals, "BonusFeats", Number);
		epicfeatpos = GetValNumber(Vals, "EpicFeats", Number);
		spellfailpos = GetValNumber(Vals, "SpellFailure", Number);
		useeffectspos = GetValNumber(Vals, "Effects", Number);
		attachclasspos = GetValNumber(Vals, "AttachClass", Number);
		noeqpos = GetValNumber(Vals, "NoEq", Number);
		psidispos = GetValNumber(Vals, "PsiDisc", Number);
		psicryspos = GetValNumber(Vals, "PsiCrys", Number);
		forceattackpos = GetValNumber(Vals, "ForceAttack", Number);
		forceweapontypepos = GetValNumber(Vals, "ForceWeaponType", Number);
		naturalenhpos = GetValNumber(Vals, "NaturalEnhence", Number);
		derrivepos = GetValNumber(Vals, "Derrive", Number);
		copyspellpos = GetValNumber(Vals, "CopySpells", Number);
		npcpos = GetValNumber(Vals, "NPC", Number);
		spellattrpos = GetValNumber(Vals, "SpellAttr", Number);
		bonusclassskillpos = GetValNumber(Vals, "BonusClassSkills", Number);
		forceweaponpos = GetValNumber(Vals, "ForceWeapon", Number);
		nometalpos = GetValNumber(Vals, "NoMetal", Number);

		for (i = 0;i < 6;i++)
		{
			attr[i] = GetValNumber(Vals, GetAttributeName(i), Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in CharSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsCharSource*) TargetStruct)->Name = Vals[name];
	sscanf(Vals[tw], "W%d", &(((clsCharSource*) TargetStruct)->TW));
	for (i = 0;i < 6;i++)
	{
		((clsCharSource*) TargetStruct)->AttributePriority[i] = atoi(Vals[attr[i]]);
	}
	((clsCharSource*) TargetStruct)->Probability = atoi(Vals[prob]);
	((clsCharSource*) TargetStruct)->GA = atoi(Vals[ga]);
	((clsCharSource*) TargetStruct)->RWRef = atoi(Vals[rwref]);
	((clsCharSource*) TargetStruct)->RWWil = atoi(Vals[rwwil]);
	((clsCharSource*) TargetStruct)->RWZaeh = atoi(Vals[rwzaeh]);
	((clsCharSource*) TargetStruct)->PreferedAttack = atoi(Vals[attack]);
	((clsCharSource*) TargetStruct)->Skills = atoi(Vals[skills]);
	((clsCharSource*) TargetStruct)->Prestige = atoi(Vals[prestige]);
	((clsCharSource*) TargetStruct)->MaxLevel = atoi(Vals[maxlvl]);
	((clsCharSource*) TargetStruct)->SpellType = atoi(Vals[spellpos]);
	((clsCharSource*) TargetStruct)->SpellType2 = atoi(Vals[spelltype2pos]);
	((clsCharSource*) TargetStruct)->IncreaseSpellType = atoi(Vals[incspellpos]);
	
	((clsCharSource*) TargetStruct)->SpontanCast = atoi(Vals[spontanpos]);
	((clsCharSource*) TargetStruct)->EpicFeats = atoi(Vals[epicfeatpos]);

	((clsCharSource*) TargetStruct)->SpontanCast2 = ((clsCharSource*) TargetStruct)->SpontanCast / 2;
	((clsCharSource*) TargetStruct)->SpontanCast &= 1;

	((clsCharSource*) TargetStruct)->Domains = atoi(Vals[domainpos]);
	((clsCharSource*) TargetStruct)->Specialize = atoi(Vals[specialpos]);
	((clsCharSource*) TargetStruct)->PowerType = atoi(Vals[powerpos]);
	((clsCharSource*) TargetStruct)->SpellFailure = atoi(Vals[spellfailpos]);

	((clsCharSource*) TargetStruct)->UseEffects = atoi(Vals[useeffectspos]);

	((clsTempCharSource*) TempStruct)->ReqStr = Vals[reqpos];
	((clsTempCharSource*) TempStruct)->SkillStr = Vals[skillreqpos];
	((clsTempCharSource*) TempStruct)->FeatStr = Vals[featreqpos];

	str_replace(',', ' ', ((clsTempCharSource*) TempStruct)->ReqStr.buffer);
	str_replace(';', 0, ((clsTempCharSource*) TempStruct)->ReqStr.buffer);

	str_replace(';', 0, ((clsTempCharSource*) TempStruct)->FeatStr.buffer);

	str_replace(',', ' ', ((clsTempCharSource*) TempStruct)->SkillStr.buffer);
	str_replace(';', 0, ((clsTempCharSource*) TempStruct)->SkillStr.buffer);

	((clsCharSource*) TargetStruct)->BonusFeatType = Vals[bonusfeattypepos];
	str_replace(';', 0, ((clsCharSource*) TargetStruct)->BonusFeatType.buffer);
	
	((clsCharSource*) TargetStruct)->BonusFeats = Vals[bonusfeatpos];
	str_replace(':', ' ', ((clsCharSource*) TargetStruct)->BonusFeats.buffer);
	str_replace(';', 0, ((clsCharSource*) TargetStruct)->BonusFeats.buffer);

	((clsTempCharSource*) TempStruct)->AttachClass = Vals[attachclasspos];

	((clsCharSource*) TargetStruct)->NoEq = atoi(Vals[noeqpos]);
	((clsCharSource*) TargetStruct)->PsionicDisciple = atoi(Vals[psidispos]);
	((clsCharSource*) TargetStruct)->PsiCrystal = atoi(Vals[psicryspos]);
	((clsCharSource*) TargetStruct)->ForceAttack = atoi(Vals[forceattackpos]);
	((clsCharSource*) TargetStruct)->ForceWeaponType = atoi(Vals[forceweapontypepos]);
	((clsCharSource*) TargetStruct)->NaturalEnhence = atoi(Vals[naturalenhpos]);

	((clsTempCharSource*) TempStruct)->Derrive = Vals[derrivepos];
	((clsTempCharSource*) TempStruct)->CopySpellList = Vals[copyspellpos];

	((clsCharSource*) TargetStruct)->NPC = atoi(Vals[npcpos]);
	((clsCharSource*) TargetStruct)->SpellAttr = atoi(Vals[spellattrpos]);
	((clsCharSource*) TargetStruct)->BonusClassSkills = atoi(Vals[bonusclassskillpos]);

	((clsCharSource*) TargetStruct)->NoMetal = atoi(Vals[nometalpos]);
	((clsTempCharSource*) TempStruct)->ForceWeapon = Vals[forceweaponpos];
	
	if (bnf::bnfparse(Vals[scriptpos], &(((clsCharSource*) TargetStruct)->Script)) ||
		bnf::bnfparse(Vals[classfeatpos], &(((clsCharSource*) TargetStruct)->ClassFeats)))
	{
		printf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

void CharSourceExit()
{
	int i;
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		freel(Source.CharSource[i].Script);
		freel(Source.CharSource[i].ClassFeats);
	}
	delete[] Source.CharSource;
}
